Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/legend/impl/DrawUtils.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/legend/impl/DrawUtils.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/legend/impl/DrawUtils.java	(revision 43510)
@@ -0,0 +1,192 @@
+package org.gvsig.symbology.fmap.mapcontext.rendering.legend.impl;
+
+import java.awt.Graphics2D;
+import java.awt.geom.AffineTransform;
+import java.awt.geom.PathIterator;
+import org.gvsig.fmap.dal.feature.Feature;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryException;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.GeometryManager;
+import org.gvsig.fmap.geom.aggregate.Aggregate;
+import org.gvsig.fmap.geom.aggregate.MultiLine;
+import org.gvsig.fmap.geom.aggregate.MultiPolygon;
+import org.gvsig.fmap.geom.aggregate.MultiSurface;
+import org.gvsig.fmap.geom.exception.CreateGeometryException;
+import org.gvsig.fmap.geom.operation.GeometryOperationException;
+import org.gvsig.fmap.geom.primitive.Curve;
+import org.gvsig.fmap.geom.primitive.GeneralPathX;
+import org.gvsig.fmap.geom.primitive.Surface;
+import org.gvsig.fmap.geom.type.GeometryType;
+import org.gvsig.fmap.mapcontext.ViewPort;
+import org.gvsig.fmap.mapcontext.rendering.symbols.CartographicSupport;
+import org.gvsig.fmap.mapcontext.rendering.symbols.ISymbol;
+import org.gvsig.tools.task.Cancellable;
+
+public class DrawUtils {
+
+    private static GeometryManager geometryManager = null;
+
+    private static GeometryManager getGeometryManager() {
+        if( geometryManager == null ) {
+            geometryManager = GeometryLocator.getGeometryManager();
+        }
+        return geometryManager;
+    }
+
+    public static void drawInts(Graphics2D g, ViewPort viewPort, Cancellable cancel, double dpi, ISymbol symbol, Feature feature, Geometry geom) throws GeometryOperationException {
+
+        try {
+            if( geom instanceof Aggregate ) {
+                for( Geometry prim : (Aggregate) geom ) {
+                    drawInts(g, viewPort, cancel, dpi, symbol, feature, prim);
+                }
+                return;
+            }
+
+            double previousSize = ((CartographicSupport) symbol).toCartographicSize(viewPort, dpi, geom);
+            // draw it as normally
+            Geometry transformedGeometry;
+            transformedGeometry = transformGeometry(geom.cloneGeometry(), viewPort.getAffineTransform());
+
+            // the AffineTransform has to be null because the transformToInts method reprojects the geometry
+            symbol.draw(g, null, transformedGeometry, feature, cancel);
+
+            // restore previous size
+            ((CartographicSupport) symbol).setCartographicSize(previousSize, geom);
+        } catch (GeometryException e) {
+            throw new GeometryOperationException(e);
+        }
+    }
+
+    public static void drawInts(Graphics2D g, ViewPort viewPort, ISymbol symbol, Feature feature, Geometry geom) throws GeometryOperationException {
+
+        try {
+            if( geom instanceof Aggregate ) {
+                for( Geometry prim : (Aggregate) geom ) {
+                    drawInts(g, viewPort, symbol, feature, prim);
+                }
+                return;
+            }
+            Geometry transformedGeometry = transformGeometry(geom.cloneGeometry(), viewPort.getAffineTransform());
+            symbol.draw(g, viewPort.getAffineTransform(), transformedGeometry, feature, null);
+
+        } catch (GeometryException e) {
+            throw new GeometryOperationException(e);
+        }
+    }
+
+    /**
+     * @param geom
+     * @param affineTransform
+     * @return
+     * @throws GeometryException
+     */
+    private static Geometry transformGeometry(Geometry geom, AffineTransform affineTransform) throws GeometryException {
+        if( geom.canBeTransformed(affineTransform) ) {
+            geom.transform(affineTransform);
+            return geom;
+        }
+        if( geom instanceof Curve || geom instanceof Curve ) {
+            MultiLine lines = geom.toLines();
+            lines.transform(affineTransform);
+            return lines;
+        }
+        if( geom instanceof Surface || geom instanceof MultiSurface ) {
+            MultiPolygon polygons = geom.toPolygons();
+            polygons.transform(affineTransform);
+            return polygons;
+        }
+        return null;
+    }
+
+    private static Geometry transformToInts(Geometry gp, AffineTransform at) throws CreateGeometryException {
+        GeneralPathX newGp = new GeneralPathX();
+        double[] theData = new double[6];
+        double[] aux = new double[6];
+
+        // newGp.reset();
+        PathIterator theIterator;
+        int theType;
+        int numParts = 0;
+
+        java.awt.geom.Point2D ptDst = new java.awt.geom.Point2D.Double();
+        java.awt.geom.Point2D ptSrc = new java.awt.geom.Point2D.Double();
+        boolean bFirst = true;
+        int xInt, yInt, antX = -1, antY = -1;
+
+        theIterator = gp.getPathIterator(null); //, flatness);
+        int numSegmentsAdded = 0;
+        while( !theIterator.isDone() ) {
+            theType = theIterator.currentSegment(theData);
+
+            switch( theType ) {
+            case PathIterator.SEG_MOVETO:
+                numParts++;
+                ptSrc.setLocation(theData[0], theData[1]);
+                at.transform(ptSrc, ptDst);
+                antX = (int) ptDst.getX();
+                antY = (int) ptDst.getY();
+                newGp.moveTo(antX, antY);
+                numSegmentsAdded++;
+                bFirst = true;
+                break;
+
+            case PathIterator.SEG_LINETO:
+                ptSrc.setLocation(theData[0], theData[1]);
+                at.transform(ptSrc, ptDst);
+                xInt = (int) ptDst.getX();
+                yInt = (int) ptDst.getY();
+                if( (bFirst) || ((xInt != antX) || (yInt != antY)) ) {
+                    newGp.lineTo(xInt, yInt);
+                    antX = xInt;
+                    antY = yInt;
+                    bFirst = false;
+                    numSegmentsAdded++;
+                }
+                break;
+
+            case PathIterator.SEG_QUADTO:
+                at.transform(theData, 0, aux, 0, 2);
+                newGp.quadTo(aux[0], aux[1], aux[2], aux[3]);
+                numSegmentsAdded++;
+                break;
+
+            case PathIterator.SEG_CUBICTO:
+                at.transform(theData, 0, aux, 0, 3);
+                newGp.curveTo(aux[0], aux[1], aux[2], aux[3], aux[4], aux[5]);
+                numSegmentsAdded++;
+                break;
+
+            case PathIterator.SEG_CLOSE:
+                if( numSegmentsAdded < 3 ) {
+                    newGp.lineTo(antX, antY);
+                }
+                newGp.closePath();
+
+                break;
+            } //end switch
+
+            theIterator.next();
+        } //end while loop
+
+        Geometry geom = null;
+        GeometryType geometryType = gp.getGeometryType();
+
+        if( geometryType.isTypeOf(Geometry.TYPES.POINT) ) {
+            geom = getGeometryManager().createPoint(ptDst.getX(), ptDst.getY(), Geometry.SUBTYPES.GEOM2D);
+        } else if( geometryType.isTypeOf(Geometry.TYPES.MULTIPOINT) ) {
+            geom = getGeometryManager().createMultiPoint(newGp, Geometry.SUBTYPES.GEOM2D);
+        } else if( geometryType.isTypeOf(Geometry.TYPES.CURVE) ) {
+            geom = getGeometryManager().createCurve(newGp, Geometry.SUBTYPES.GEOM2D);
+        } else if( geometryType.isTypeOf(Geometry.TYPES.MULTICURVE) ) {
+            geom = getGeometryManager().createMultiCurve(newGp, Geometry.SUBTYPES.GEOM2D);
+        } else if( geometryType.isTypeOf(Geometry.TYPES.SURFACE) ) {
+            geom = getGeometryManager().createSurface(newGp, Geometry.SUBTYPES.GEOM2D);
+        } else if( geometryType.isTypeOf(Geometry.TYPES.MULTISURFACE) ) {
+            geom = getGeometryManager().createMultiSurface(newGp, Geometry.SUBTYPES.GEOM2D);
+        }
+        return geom;
+    }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/symbol/impl/MultiShapeSymbol.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/symbol/impl/MultiShapeSymbol.java	(revision 43509)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/symbol/impl/MultiShapeSymbol.java	(revision 43510)
@@ -50,6 +50,7 @@
 import org.gvsig.symbology.fmap.mapcontext.rendering.symbol.style.IMask;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.dynobject.DynStruct;
+import org.gvsig.tools.exception.NotYetImplemented;
 import org.gvsig.tools.persistence.PersistenceManager;
 import org.gvsig.tools.persistence.PersistentState;
 import org.gvsig.tools.persistence.exception.PersistenceException;
@@ -174,30 +175,27 @@
 	    }
 	}
 	
+    @Override
 	public boolean isOneDotOrPixel(Geometry geom,
 			double[] positionOfDotOrPixel, ViewPort viewPort, int dpi) {
-		switch (geom.getType()) {
-		case Geometry.TYPES.POINT: //Tipo punto
+		
+        GeometryType geomType = geom.getGeometryType();
+        if( geomType.isSubTypeOf(Geometry.TYPES.POINT) ) {
            	if (marker != null) {
 				return marker.isOneDotOrPixel(geom, positionOfDotOrPixel, viewPort, dpi);
 			}
-			break;
-		case Geometry.TYPES.CURVE:
-		case Geometry.TYPES.ARC:
-		case Geometry.TYPES.SPLINE:
-		if (line != null) {
-				return line.isOneDotOrPixel(geom, positionOfDotOrPixel, viewPort, dpi);
+
+        } else if( geomType.isSubTypeOf(Geometry.TYPES.CURVE) ) {
+            if (line != null) {
+                return line.isOneDotOrPixel(geom, positionOfDotOrPixel, viewPort, dpi);
 			}
-			break;
-
-		case Geometry.TYPES.SURFACE:
-        case Geometry.TYPES.ELLIPSE:
-		case Geometry.TYPES.CIRCLE:
+            
+        } else if( geomType.isSubTypeOf(Geometry.TYPES.SURFACE) ) {
 			if (fill != null) {
 				return fill.isOneDotOrPixel(geom, positionOfDotOrPixel, viewPort, dpi);
 			}
-			break;
-		}
+            
+        }
 		if (!geom.isSimple()){
 			Aggregate aggregate = (Aggregate)geom;			
 			for (int i=0 ; i<aggregate.getPrimitivesNumber() ; i++){
@@ -332,34 +330,28 @@
 		}
 	}
 
-//	public String getClassName() {
-//		return getClass().getName();
-//	}
-
+    @Override
 	public void print(Graphics2D g, AffineTransform at, Geometry geom, PrintAttributes properties) {
-		switch (geom.getType()) {
-		case Geometry.TYPES.POINT: //Tipo punto
+        GeometryType geomType = geom.getGeometryType();
+        if( geomType.isTypeOf(Geometry.TYPES.POINT) ) {
            	if (marker != null) {
 				marker.print(g, at, geom, properties);
 			}
-			break;
-		case Geometry.TYPES.CURVE:
-		case Geometry.TYPES.ARC:
+
+        } else if( geomType.isTypeOf(Geometry.TYPES.CURVE) ) {
 			if (line != null) {
 				line.print(g, at, geom, properties);
 			}
-			break;
 
-		case Geometry.TYPES.SURFACE:
-		case Geometry.TYPES.ELLIPSE:
-        case Geometry.TYPES.CIRCLE:
+        } else if( geomType.isTypeOf(Geometry.TYPES.SURFACE) ) {
 			if (fill != null) {
 				fill.print(g, at, geom, properties);
 			}
-			break;
-		}
+
+        }
 	}
 
+    @Override
 	public double getRotation() {
 		if (marker != null) {
 			return marker.getRotation();
@@ -459,6 +451,7 @@
 		}
 	}
 
+    @Override
 	public int getUnit() {
 		if (marker != null) {
 			return marker.getUnit();
@@ -469,109 +462,114 @@
 		return -1;
 	}
 
+    @Override
 	public void setMask(IMask mask) {
-		// TODO Implement it
-		throw new Error("Not yet implemented!");
+		throw new NotYetImplemented();
 
 	}
 
+    @Override
 	public int getReferenceSystem() {
 		return this.referenceSystem;
 	}
 
+    @Override
 	public void setReferenceSystem(int system) {
 		this.referenceSystem = system;
 
 	}
 
+    @Override
 	public double toCartographicSize(ViewPort viewPort, double dpi, Geometry geom) {
-		switch (geom.getType()) {
-		case Geometry.TYPES.POINT: //Tipo punto
+        GeometryType geomType = geom.getGeometryType();
+        if( geomType.isTypeOf(Geometry.TYPES.POINT) ) {
         	if (marker != null) {
 				return marker.toCartographicSize(viewPort, dpi, geom);
 			}
-		case Geometry.TYPES.CURVE:
-		case Geometry.TYPES.ARC:
+
+        } else if( geomType.isTypeOf(Geometry.TYPES.CURVE) ) {
 			if (line != null) {
 				return line.toCartographicSize(viewPort, dpi, geom);
 			}
-		case Geometry.TYPES.SURFACE:
-		case Geometry.TYPES.ELLIPSE:
-		case Geometry.TYPES.CIRCLE:
+
+        } else if( geomType.isTypeOf(Geometry.TYPES.SURFACE) ) {
 			LOG.warn("Cartographic size does not have any sense for fill symbols");
 
-		}
+        }
 		return -1;
 	}
 
+    @Override
 	public void setCartographicSize(double cartographicSize, Geometry geom) {
-		switch (geom.getType()) {
-		case Geometry.TYPES.POINT: //Tipo punto
+        GeometryType geomType = geom.getGeometryType();
+        if( geomType.isTypeOf(Geometry.TYPES.POINT) ) {
         	if (marker != null) {
 				marker.setCartographicSize(cartographicSize, null);
 			}
-        	break;
-		case Geometry.TYPES.CURVE:
-		case Geometry.TYPES.ARC:
+
+        } else if( geomType.isTypeOf(Geometry.TYPES.CURVE) ) {
 			if (line != null) {
 				line.setCartographicSize(cartographicSize, null);
 			}
-        	break;
-		case Geometry.TYPES.SURFACE:
-		case Geometry.TYPES.ELLIPSE:
-	    case Geometry.TYPES.CIRCLE:
+
+        } else if( geomType.isTypeOf(Geometry.TYPES.SURFACE) ) {
 	    	LOG.warn("Cartographic size does not have any sense for fill symbols");
-		}
+
+        }
 	}
 
 
+    @Override
 	public double getCartographicSize(ViewPort viewPort, double dpi, Geometry geom) {
-		switch (geom.getType()) {
-		case Geometry.TYPES.POINT: //Tipo punto
-        	return CartographicSupportToolkit.
-			getCartographicLength(marker,
-								  getSize(),
-								  viewPort,
-								  dpi);
-		case Geometry.TYPES.CURVE:
-		case Geometry.TYPES.ARC:
-			return CartographicSupportToolkit.
-			getCartographicLength(line,
-								  getSize(),
-								  viewPort,
-								  dpi);
-		case Geometry.TYPES.SURFACE:
-     	case Geometry.TYPES.ELLIPSE:
-	    case Geometry.TYPES.CIRCLE:
+        GeometryType geomType = geom.getGeometryType();
+        if( geomType.isTypeOf(Geometry.TYPES.POINT) ) {
+        	return CartographicSupportToolkit.getCartographicLength(
+                marker, getSize(), viewPort, dpi
+            );
+
+        } else if( geomType.isTypeOf(Geometry.TYPES.CURVE) ) {
+			return CartographicSupportToolkit.getCartographicLength(
+                line, getSize(), viewPort, dpi
+            );
+
+        } else if( geomType.isTypeOf(Geometry.TYPES.SURFACE) ) {
 	    	LOG.warn("Cartographic size does not have any sense for fill symbols");
-		}
+
+        }
 		return -1;
 	}
 
+    @Override
 	public IMarkerSymbol getMarkerSymbol() {
 		return marker;
 	}
 
+    @Override
 	public ILineSymbol getLineSymbol() {
 		return line;
 	}
 
+    @Override
 	public IFillSymbol getFillSymbol() {
 		return fill;
 	}
 
+    @Override
 	public void setMarkerSymbol(IMarkerSymbol markerSymbol) {
 		this.marker = markerSymbol;
 	}
 
+    @Override
 	public void setLineSymbol(ILineSymbol lineSymbol) {
 		this.line = lineSymbol;
 	}
 
+    @Override
 	public void setFillSymbol(IFillSymbol fillFillSymbol) {
 		this.fill = fillFillSymbol;
 	}
 
+    @Override
 	public boolean hasFill() {
 	if (fill == null) {
 		return false;
@@ -579,23 +577,24 @@
 	return fill.hasFill();
 	}
 
+    @Override
 	public void setHasFill(boolean hasFill) {
 		if (fill != null) {
 			fill.setHasFill(hasFill);
-//			this.hasFill = hasFill;
 		}
 	}
 
+    @Override
 	public boolean hasOutline() {
-		// TODO Auto-generated method stub
 		return false;
 	}
 
+    @Override
 	public void setHasOutline(boolean hasOutline) {
-		// TODO Auto-generated method stub
 
 	}
 
+    @Override
 	public Object clone() throws CloneNotSupportedException {
 		MultiShapeSymbol copy = (MultiShapeSymbol) super.clone();
 
@@ -622,6 +621,7 @@
 		return copy;
 	}
 
+    @Override
 	public void loadFromState(PersistentState state)
 			throws PersistenceException {
 		setDescription(state.getString(FIELD_DESCRIPTION));
@@ -630,6 +630,7 @@
 		setLineSymbol((ILineSymbol) state.get(FIELD_LINE));
 	}
 
+    @Override
 	public void saveToState(PersistentState state) throws PersistenceException {
 		state.set(FIELD_DESCRIPTION, getDescription());
 		state.set(FIELD_FILL, getFillSymbol());
@@ -639,6 +640,7 @@
 
 	public static class RegisterPersistence implements Callable {
 
+        @Override
 		public Object call() throws Exception {
 			PersistenceManager manager = ToolsLocator.getPersistenceManager();
 			if( manager.getDefinition(MULTI_SHAPE_SYMBOL_PERSISTENCE_DEFINITION_NAME)==null ) {
@@ -665,6 +667,7 @@
 
 	public static class RegisterSymbol implements Callable {
 
+        @Override
 		public Object call() throws Exception {
 	        int[] shapeTypes;
 	        SymbolManager manager = MapContextLocator.getSymbolManager();

Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/symbol/line/impl/AbstractLineSymbol.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/symbol/line/impl/AbstractLineSymbol.java	(revision 43509)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/symbol/line/impl/AbstractLineSymbol.java	(revision 43510)
@@ -98,14 +98,17 @@
 		setLineColor(color);
 	}
 
+    @Override
 	public int getOnePointRgb() {
 		return color.getRGB();
 	}
 
+    @Override
 	public final int getSymbolType() {
 		return Geometry.TYPES.CURVE;
 	}
 
+    @Override
 	public void getPixExtentPlus(Geometry geom, float[] distances, ViewPort viewPort, int dpi) {
 		float cs = (float) getCartographicSize(viewPort, dpi, geom);
 		// TODO and add the line offset
@@ -113,16 +116,12 @@
 		distances[1] = cs;
 	}
 
+    @Override
 	public boolean isSuitableFor(Geometry geom) {
-		switch(geom.getType()) {
-		case Geometry.TYPES.CURVE:
-		case Geometry.TYPES.ARC:
-		case Geometry.TYPES.LINE:
-			return true;
-		}
-		return false;
+        return geom.getGeometryType().isTypeOf(Geometry.TYPES.CURVE);
 	}
 
+    @Override
 	public ILineStyle getLineStyle() {
 		return lineStyle;
 	}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/symbol/line/impl/MultiLayerLineSymbol.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/symbol/line/impl/MultiLayerLineSymbol.java	(revision 43509)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.lib/org.gvsig.symbology.lib.impl/src/main/java/org/gvsig/symbology/fmap/mapcontext/rendering/symbol/line/impl/MultiLayerLineSymbol.java	(revision 43510)
@@ -177,15 +177,12 @@
 		return selectionSymbol;
 	}
 
+    @Override
 	public boolean isSuitableFor(Geometry geom) {
-	      switch(geom.getType()) {
-	        case Geometry.TYPES.CURVE:
-	        case Geometry.TYPES.LINE:
-	            return true;
-	        }
-	        return false;
+        return geom.getGeometryType().isTypeOf(Geometry.TYPES.CURVE);
 	}
 
+    @Override
 	public void print(Graphics2D g, AffineTransform at, Geometry geom, PrintAttributes properties) {
 		for (int i = 0; layers != null && i < layers.length; i++) {
 			layers[i].print(g, at, geom, properties);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.swing/org.gvsig.symbology.swing.api/src/main/java/org/gvsig/app/gui/styling/SymbolSelector.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.swing/org.gvsig.symbology.swing.api/src/main/java/org/gvsig/app/gui/styling/SymbolSelector.java	(revision 43509)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.swing/org.gvsig.symbology.swing.api/src/main/java/org/gvsig/app/gui/styling/SymbolSelector.java	(revision 43510)
@@ -152,12 +152,13 @@
 		private Geometry dummyPolygonGeom = null;
 		private boolean isInitialized = false;
 
+        @Override
 		public boolean accepts(Object obj) {
 			if (!isInitialized){
 				try {
 					dummyPointGeom = geomManager.createPoint(0, 0, SUBTYPES.GEOM2D);
-					dummyLineGeom = geomManager.create(TYPES.CURVE, SUBTYPES.GEOM2D);
-					dummyPolygonGeom = geomManager.create(TYPES.SURFACE, SUBTYPES.GEOM2D);
+					dummyLineGeom = geomManager.createLine(SUBTYPES.GEOM2D);
+					dummyPolygonGeom = geomManager.createPolygon(SUBTYPES.GEOM2D);
 				} catch (CreateGeometryException e) {
 					logger.error("Error creating a geometry", e);
 				}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.swing/org.gvsig.symbology.swing.api/src/main/java/org/gvsig/app/gui/styling/SymbolLayerManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.swing/org.gvsig.symbology.swing.api/src/main/java/org/gvsig/app/gui/styling/SymbolLayerManager.java	(revision 43509)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.swing/org.gvsig.symbology.swing.api/src/main/java/org/gvsig/app/gui/styling/SymbolLayerManager.java	(revision 43510)
@@ -156,9 +156,9 @@
         		shapeType = Geometry.TYPES.SURFACE;
 			}
 
-        	if (shapeType != -1)
-				symbol.addLayer(MapContextLocator.getSymbolManager()
-						.createSymbol(shapeType));
+        	if (shapeType != -1) {
+				symbol.addLayer(MapContextLocator.getSymbolManager().createSymbol(shapeType));
+            }
    		}
         initialize();
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.swing/org.gvsig.symbology.swing.api/src/main/java/org/gvsig/app/gui/styling/MultiShapeSymbolSelector.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.swing/org.gvsig.symbology.swing.api/src/main/java/org/gvsig/app/gui/styling/MultiShapeSymbolSelector.java	(revision 43509)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.symbology/org.gvsig.symbology.swing/org.gvsig.symbology.swing.api/src/main/java/org/gvsig/app/gui/styling/MultiShapeSymbolSelector.java	(revision 43510)
@@ -98,14 +98,11 @@
     private MultiShapeSymbolSelector() throws BaseException {
 
         GeometryType
-        gt = getGeomManager().getGeometryType(Geometry.TYPES.POINT,
-            SUBTYPES.GEOM2D);
+        gt = getGeomManager().getGeometryType(Geometry.TYPES.POINT, SUBTYPES.GEOM2D);
         markerSelector = new SymbolSelectorBrowser(gt, true);
-        gt = getGeomManager().getGeometryType(Geometry.TYPES.CURVE,
-            SUBTYPES.GEOM2D);
+        gt = getGeomManager().getGeometryType(Geometry.TYPES.CURVE, SUBTYPES.GEOM2D);
         lineSelector = new SymbolSelectorBrowser(gt, true);
-        gt = getGeomManager().getGeometryType(Geometry.TYPES.SURFACE,
-            SUBTYPES.GEOM2D);
+        gt = getGeomManager().getGeometryType(Geometry.TYPES.SURFACE, SUBTYPES.GEOM2D);
         fillSelector = new SymbolSelectorBrowser(gt, true);
 
         initialize(true);
@@ -116,33 +113,24 @@
 		this.wi = wi;
 	}
 	
-	MultiShapeSymbolSelector(Object currSymbol) {
-                IMultiShapeSymbol sym = null;
-                try {
-                    sym = (IMultiShapeSymbol) currSymbol;
-                } catch(Exception ex) {
-                    logger.warn("Incorrect symbol type, use default.",ex);
-                }
-		if (sym == null) {
-			markerSelector = (SymbolSelector) SymbolSelector
-					.createSymbolSelector(null, Geometry.TYPES.POINT);
-			lineSelector = (SymbolSelector) SymbolSelector
-					.createSymbolSelector(null, Geometry.TYPES.CURVE);
-			fillSelector = (SymbolSelector) SymbolSelector
-					.createSymbolSelector(null, Geometry.TYPES.SURFACE);
-		} else {
-			markerSelector = (SymbolSelector) SymbolSelector
-					.createSymbolSelector(sym.getMarkerSymbol(),
-							Geometry.TYPES.POINT);
-			lineSelector = (SymbolSelector) SymbolSelector
-					.createSymbolSelector(sym.getLineSymbol(),
-							Geometry.TYPES.CURVE);
-			fillSelector = (SymbolSelector) SymbolSelector
-					.createSymbolSelector(sym.getFillSymbol(),
-							Geometry.TYPES.SURFACE);
-		}
-		initialize(false);
-	}
+    MultiShapeSymbolSelector(Object currSymbol) {
+        IMultiShapeSymbol sym = null;
+        try {
+            sym = (IMultiShapeSymbol) currSymbol;
+        } catch (Exception ex) {
+            logger.warn("Incorrect symbol type, use default.", ex);
+        }
+        if( sym == null ) {
+            markerSelector = (SymbolSelector) SymbolSelector.createSymbolSelector(null, Geometry.TYPES.POINT);
+            lineSelector = (SymbolSelector) SymbolSelector.createSymbolSelector(null, Geometry.TYPES.CURVE);
+            fillSelector = (SymbolSelector) SymbolSelector.createSymbolSelector(null, Geometry.TYPES.SURFACE);
+        } else {
+            markerSelector = (SymbolSelector) SymbolSelector.createSymbolSelector(sym.getMarkerSymbol(), Geometry.TYPES.POINT);
+            lineSelector = (SymbolSelector) SymbolSelector.createSymbolSelector(sym.getLineSymbol(), Geometry.TYPES.CURVE);
+            fillSelector = (SymbolSelector) SymbolSelector.createSymbolSelector(sym.getFillSymbol(), Geometry.TYPES.SURFACE);
+        }
+        initialize(false);
+    }
 
 
 	private void initialize(boolean add_close_button) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.newlayer/org.gvsig.newlayer.lib/org.gvsig.newlayer.lib.impl/src/main/java/org/gvsig/newlayer/impl/FeatureTypePanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.newlayer/org.gvsig.newlayer.lib/org.gvsig.newlayer.lib.impl/src/main/java/org/gvsig/newlayer/impl/FeatureTypePanel.java	(revision 43509)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.newlayer/org.gvsig.newlayer.lib/org.gvsig.newlayer.lib.impl/src/main/java/org/gvsig/newlayer/impl/FeatureTypePanel.java	(revision 43510)
@@ -722,22 +722,16 @@
 
 	private List<ComboItemGeomType> getGeomTypes() {
 		List<ComboItemGeomType> geomTypes = new ArrayList<ComboItemGeomType>();
-		geomTypes
-				.add(new ComboItemGeomType("GEOMETRY", Geometry.TYPES.GEOMETRY));
+		geomTypes.add(new ComboItemGeomType("GEOMETRY", Geometry.TYPES.GEOMETRY));
 		geomTypes.add(new ComboItemGeomType("POINT", Geometry.TYPES.POINT));
-		geomTypes.add(new ComboItemGeomType("CURVE", Geometry.TYPES.CURVE));
-		geomTypes.add(new ComboItemGeomType("SURFACE", Geometry.TYPES.SURFACE));
+		geomTypes.add(new ComboItemGeomType("LINE", Geometry.TYPES.LINE));
+		geomTypes.add(new ComboItemGeomType("POLYGON", Geometry.TYPES.POLYGON));
 		geomTypes.add(new ComboItemGeomType("SOLID", Geometry.TYPES.SOLID));
-		geomTypes.add(new ComboItemGeomType("AGGREGATE",
-				Geometry.TYPES.AGGREGATE));
-		geomTypes.add(new ComboItemGeomType("MULTIPOINT",
-				Geometry.TYPES.MULTIPOINT));
-		geomTypes.add(new ComboItemGeomType("MULTICURVE",
-				Geometry.TYPES.MULTICURVE));
-		geomTypes.add(new ComboItemGeomType("MULTISURFACE",
-				Geometry.TYPES.MULTISURFACE));
-		geomTypes.add(new ComboItemGeomType("MULTISOLID",
-				Geometry.TYPES.MULTISOLID));
+		geomTypes.add(new ComboItemGeomType("AGGREGATE", Geometry.TYPES.AGGREGATE));
+		geomTypes.add(new ComboItemGeomType("MULTIPOINT", Geometry.TYPES.MULTIPOINT));
+		geomTypes.add(new ComboItemGeomType("MULTILINE", Geometry.TYPES.MULTILINE));
+		geomTypes.add(new ComboItemGeomType("MULTIPOLYGON", Geometry.TYPES.MULTIPOLYGON));
+		geomTypes.add(new ComboItemGeomType("MULTISOLID", Geometry.TYPES.MULTISOLID));
 
 		return geomTypes;
 	}
